<!--
@license
Copyright (c) 2015 The Polymer Project Authors. All rights reserved.
This code may only be used under the BSD style license found at http://polymer.github.io/LICENSE.txt
The complete set of authors may be found at http://polymer.github.io/AUTHORS.txt
The complete set of contributors may be found at http://polymer.github.io/CONTRIBUTORS.txt
Code distributed by Google as part of the polymer project is also
subject to an additional IP rights grant found at http://polymer.github.io/PATENTS.txt
-->

<!-- Polymer Elements -->
<link rel="import" href="../polymer/polymer.html">

<link rel="import" href="../neon-animation/neon-animated-pages.html">
<link rel="import" href="../neon-animation/neon-animatable.html">
<link rel="import" href="../neon-animation/neon-animations.html">

<!--
`<hook-carousel>` is a carousel element. Any child elements are treated as slides. Define the desired `width` and `height` properties, then apply the `fluid` property to preserve the aspect ratio. Use the `indicators` attribute to create indicator nav dots for each image added but only if there are more than one image(s) in the manifest. Use the `arrows` attribute to create next and previous navigation arrows.  The `fade-in-out` attribute changes the animation from slide in/out to fade in/out.

Example:

    <hook-carousel>

      <img src="../path/to/image.jpg">
      <img src="../path/to/image.png">
      <img src="../path/to/image.gif">
      <img src="../path/to/image.jpeg">

    </hook-carousel>

A carousel with the `fluid` attribute will set its width to 100% to fill the parent container, while adding padding-top to preserve the aspect ratio provided by width and height. If width and height have not been set, the player will fall back to a 16:9 aspect ratio. This is useful for responsive designs where you don't want to introduce letterboxing on your video.

    <hook-carousel width="960px" height="530px" fluid>

      <img src="../path/to/image.jpg">
      <img src="../path/to/image.png">
      <img src="../path/to/image.gif">
      <img src="../path/to/image.jpeg">

    </hook-carousel>

A carousel with the `indicators` attribute will create pagination indicators for each slide added to the carousel.

    <hook-carousel width="960px" height="530px" indicators>

      <img src="../path/to/image.jpg">
      <img src="../path/to/image.png">
      <img src="../path/to/image.gif">
      <img src="../path/to/image.jpeg">

    </hook-carousel>

A carousel with the `arrows` attribute will display left/previous and right/next navigation arrows.

    <hook-carousel width="960px" height="530px" arrows>

      <img src="../path/to/image.jpg">
      <img src="../path/to/image.png">
      <img src="../path/to/image.gif">
      <img src="../path/to/image.jpeg">

    </hook-carousel>

A carousel with the `locked` attribute will lock the directional navigation to stop at the beginning and end of the carousel.

    <hook-carousel width="960px" height="530px" locked>

      <img src="../path/to/image.jpg">
      <img src="../path/to/image.png">
      <img src="../path/to/image.gif">
      <img src="../path/to/image.jpeg">

    </hook-carousel>

A carousel with the `fade-in-out` attribute will use a fade in and out animation to go through the slides.

    <hook-carousel width="960px" height="530px" fade-in-out>

      <img src="../path/to/image.jpg">
      <img src="../path/to/image.png">
      <img src="../path/to/image.gif">
      <img src="../path/to/image.jpeg">

    </hook-carousel>

A carousel with the `autoplay` attribute will autoplay the slides based on the `transition-time` attribute.
`autoplay` will stop on interaction (_onSwipe & _onTap).

    <hook-carousel autoplay transition-time="3000">

      <img src="../path/to/image.jpg">
      <img src="../path/to/image.png">
      <img src="../path/to/image.gif">
      <img src="../path/to/image.jpeg">

    </hook-carousel>

### Styling

The following custom properties and mixins are available for styling:

Custom property | Description | Default
----------------|-------------|----------
`--indicator-width` | indicator width value | 15px
`--indicator-height` | indicator height value | 15px
`--indicator-color` | indicator color | grey
`--indicator-color-selected` | indicator color when selected/active | light grey
`--indicator-border-radius` | indicator border-radius value | 50%
`--nav-arrow-width` | carousel nav arrow width value | 15px
`--nav-arrow-height` | carousel nav arrow height value | 25px
`--nav-arrow-color` | carousel nav arrow color | white

@element hook-carousel
@demo demo/index.html
-->

<dom-module id="hook-carousel">
  <template>

    <style>

      /**
       * Host styles
       */

      :host {
        --indicator-width: 15px;
        --indicator-height: 15px;
        --indicator-color: #a8a8a8;
        --indicator-color-selected: #e1e1e1;
        --indicator-border-radius: 50%;
        --nav-arrow-width: 15px;
        --nav-arrow-height: 25px;       
        --nav-arrow-color: #ffffff;
          
        display: block;
        position: relative;
        cursor: default;
        -webkit-box-sizing: border-box;
           -moz-box-sizing: border-box;
                box-sizing: border-box;
      }

      /**
       * Disable text highlighting on carousel elements/cards
       */
      :host,
      #carousel ::content img {
        -webkit-touch-callout: none;
           -moz-touch-callout: none;
            -ms-touch-callout: none;
                touch-callout: none;
        -webkit-user-select: none;
           -moz-user-select: none;
            -ms-user-select: none;
                user-select: none;
        -webkit-user-drag: none;
           -moz-user-drag: none;
            -ms-user-drag: none;
                user-drag: none;
      }

      #carousel ::content img {
        width: 100%;
        max-width: 100%;
        height: auto;
      }

      /**
       * Container styles
       */

      #container {
        max-width: 100%;
        max-height: 100%;
      }

      /**
       * Neon Animated Pages styles
       */

      #carousel {
        position: absolute;
        top: 0;
        left: 0;
        width: 100%;
        height: 100%;
        overflow: hidden;
      }

      #carousel ::content > * {
        bottom: auto;
      }

      /**
       * Indicator styles
       */

      #indicators {
        position: absolute;
        bottom: 0;
        left: 0;
        margin: 0;
        padding: 0;
        width: 100%;
        visibility: hidden;
        opacity: 0;
        z-index: -1;
        display: -webkit-box;
        display: -moz-box;
        display: -ms-flexbox;
        display: -webkit-flex;
        display: flex;
        -webkit-flex-direction: row;
        -moz-flex-direction: row;
        -ms-flex-direction: row;
        -o-flex-direction: row;
        flex-direction: row;
        -webkit-box-pack: center;
        -moz-box-pack: center;
        -ms-flex-pack: center;
        -webkit-justify-content: center;
        justify-content: center;
        -webkit-box-align: center;
        -moz-box-align: center;
        -ms-flex-align: center;
        -webkit-align-items: center;
        align-items: center;

      }

      #indicators button {
        font-weight: 300;
        font-size: 30px;
        line-height: 80px;
        padding: 0 5px;
        text-decoration: none;
        cursor: pointer;
        background: none;
        border: none;
      }

      #indicators button:before {
        content: '';
        display: block;
        width: var(--indicator-width);
        height: var(--indicator-height);
        border-radius: var(--indicator-border-radius);
        background: var(--indicator-color);
        box-shadow: 2px 2px 5px 0px rgba(0, 0, 0, .25);
        margin: 30px 0;
        -webkit-transition: background 0.3s ease-in-out;
           -moz-transition: background 0.3s ease-in-out;
            -ms-transition: background 0.3s ease-in-out;
             -o-transition: background 0.3s ease-in-out;
                transition: background 0.3s ease-in-out;
      }

      #indicators button.selected:before {
        background: var(--indicator-color-selected);
      }

      #indicators button:focus,
      #indicators button:active,
      #indicators button.selected {
        outline: none;
        border: none;
      }

      #arrows {
        position: relative;
        bottom: -18px;
        left: 0;
        display: none;
      }

      #arrowLeft,
      #arrowRight {
        position: absolute;
        background: rgba(255, 255, 255, 0);
        z-index: 10;
        padding: 10px;
        cursor: pointer;
        width: var(--nav-arrow-width);
        height: var(--nav-arrow-height);
      }

      #arrowLeft {
        bottom: 30px;
        left: 10px;
      }

      #arrowRight {
        bottom: 30px;
        right: 10px;
      }

      .arrow-fill {
        fill: var(--nav-arrow-color);
      }

      :host([indicators]) #indicators {
        visibility: visible;
        opacity: 1;
        z-index: 1;
      }

      :host([arrows]) #arrows {
        display: block;
      }

      :host-context([dir=rtl]) #arrowLeft,
      :host-context([dir=rtl]) #arrowRight {
        -webkit-transform: scaleX(-1);
           -moz-transform: scaleX(-1);
            -ms-transform: scaleX(-1);
             -o-transform: scaleX(-1);
                transform: scaleX(-1);
      }

      @media screen and (max-width: 767px) {
        #indicators button:before {
          width: 10px;
          height: 10px;
          margin: 20px 0 10px 0;
        }

        #arrowLeft,
        #arrowRight {
          font-size: 18px;
        }

        #arrowLeft {
          left: 5px;
        }

        #arrowRight {
          right: 5px;
        }
      }

    </style>

    <div id="container" style$="{{_computeContainerStyle(width, height, ratio)}}">

      <neon-animated-pages id="carousel" items="{{_items}}" selected="{{_selected}}" entry-animation="[[_entryAnimation]]" exit-animation="[[_exitAnimation]]" on-iron-items-changed="_setSingle">

        <content select="*"></content>

      </neon-animated-pages>

      <!-- indicators -->
      <div id="indicators" class="indicators" hidden$="{{_single}}" role="listbox" aria-controls="carousel">
        <template is="dom-repeat" items="{{_items}}">

          <button class$="indicator {{_getSelectedClass(index, _selected)}}" role="option" aria-selected="{{_getSelected(index, _selected)}}" on-tap="_onTap"></button>

        </template>
      </div>

      <!-- nav arrows -->
      <div id="arrows">
        <div id="arrowLeft" on-tap="_selectPrev" hidden$="{{_single}}">
          <svg version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
             viewBox="0 0 37.4 66" style="enable-background:new 0 0 37.4 66;" xml:space="preserve">
            <g>
              <path class="arrow-fill" d="M1.6,36.1l28,28c1.7,1.7,4.4,1.7,6.1,0s1.7-4.4,0-6.1l-25-25l25-25c1.7-1.7,1.7-4.4,0-6.1s-4.4-1.7-6.1,0
                l-28,28c-0.9,0.9-1.3,2-1.3,3.1C0.4,34.1,0.8,35.2,1.6,36.1z"/>
            </g>
          </svg>
        </div>

        <div id="arrowRight" on-tap="_selectNext" hidden$="{{_single}}">
          <svg version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" x="0px" y="0px"
             viewBox="0 0 37.4 66" style="enable-background:new 0 0 37.4 66;" xml:space="preserve">
            <g>
              <path class="arrow-fill" d="M35.7,29.9l-28-28c-1.7-1.7-4.4-1.7-6.1,0S0,6.3,1.6,8l25,25l-25,25c-1.7,1.7-1.7,4.4,0,6.1
                c1.7,1.7,4.4,1.7,6.1,0l28-28c0.9-0.9,1.3-2,1.3-3.1C37,31.9,36.6,30.8,35.7,29.9z"/>
            </g>

          </svg>
        </div>
      </div>

    </div>

  </template>
  <script>
  (function() {
    'use strict';

    Polymer({
      is: 'hook-carousel',

      /**
       * Element Listeners
       * @type {Object}
       */

      listeners: {
        'swipe-left': '_onSwipe',
        'swipe-right': '_onSwipe',
        down: '_onDown',
        up: '_onUp'
      },

      /**
       * Element Properties
       * @type {Object}
       */

      properties: {
        
        _items: {
          type: Object,
          value: function() {
            return [];
          }
        },

        _selected: {
          type: Number,
          value: 0
        },

        _single: {
          type: Boolean,
          value: false
        },

        /**
         * Sets the height of the player on the page.
         * Accepts anything valid for a CSS measurement, e.g. '200px' or '50%'.
         * If the unit of measurement is left off, 'px' is assumed.
         */
        height: {
          type: String,
          value: '270px'
        },

        /**
         * Sets the width of the player on the page.
         * Accepts anything valid for a CSS measurement, e.g. '200px' or '50%'.
         * If the unit of measurement is left off, 'px' is assumed.
         */
        width: {
          type: String,
          value:'480px'
        },

        /**
         * Percentage ratio for container dimensions. Blank if not fluid.
         */
        ratio: {
          type: String,
          value: ''
        },

        /**
         * If `fluid` is set, then the carousel will set its width to 100% to fill
         * the parent container, while adding `padding-top` to preserve the
         * aspect ratio provided by `width` and `height`. If `width` and `height`
         * have not been set, the player will fall back to a 16:9 aspect ratio.
         * This is useful for responsive designs where you don't want to
         * introduce letterboxing on your video.
         */
        fluid: {
          type: Boolean,
          value: false
        },

        /**
         * horizontal threshold for swipe events
         */
        horizontalThreshold: {
          type: Number,
          value: 15
        },

        /**
         * vertical threshold for swipe events
         */
        verticalThreshold: {
          type: Number,
          value: 50
        },

        /**
         * Set the time between transitions (milliseconds)
         */
        transitionTime: {
          type: Number,
          value: 3000
        },

        /**
         * check if autoplay is initialised
         */
        _isAutoPlay: {
          type: Boolean,
          value: false
        }
      },

      /**
       * private method when fluid attribute is set
       * changes padding-top value 
       * @param  {number} width - width value
       * @param  {number} height - height value
       * @param  {number} ratio - ratio value: (padding-top)
       */
      _computeContainerStyle: function(width, height, ratio) {

        var style = 'width:' + width + '; height:' + height;

        if (ratio) {
          style += '; padding-top: ' + ratio;
        }

        return style;

      },

      /**
       * Sets fluid width/height.
       *
       * If the fluid attribute is set, the aspect ratio of the video will
       * be inferred. The element will give itself enough top padding to force
       * the carousel to use the correct aspect ratio, even as the screen size
       * changes.
       *
       */
      ready: function() {
        if (this.hasAttribute('fluid')) {
          var ratio = parseInt(this.height, 10) / parseInt(this.width, 10);
          this.width = '100%';
          this.height = 'auto';
          this.ratio = (ratio * 100) + '%';
        }

        this.autoPlayer;
        if (this.hasAttribute('autoplay')) {
          this._startAutoPlay();
        }
      },

      /**
       * Check if document is rtl
       * inverts swipe slide animation direction
       */
      _isRtl: function() {

        return document.body.dir === 'rtl';

      },

      /**
       * Set single flag for template
       * if there is only one slide
       * don't show indicators or arrows
       */
      _setSingle: function() {

        this._single = this.$.carousel.items.length < 2;

      },

      /**
       * Set Selected function
       * Sets selected slide
       * @param  {number} selected - the selected slide
       */
      _setSelected: function(selected) {

        var index = this._clamp(selected, 0, this._items.length - 1);

        if (index !== this._selected) {

          if (this.hasAttribute('fade-in-out')) {

            this._entryAnimation = 'fade-in-animation';
            this._exitAnimation = 'fade-out-animation';

          } else {

            if (this._isRtl() ? index <= this._selected : index > this._selected) {
                this._entryAnimation = 'slide-from-right-animation';
                this._exitAnimation = 'slide-left-animation';
            } else {
              this._entryAnimation = 'slide-from-left-animation';
              this._exitAnimation = 'slide-right-animation';
            }

          }

          this._selected = index;

        }

      },

      /**
       * Get Selected function
       * @param  {number} index - index of selected element.
       * @param  {number} selected - the selected element.
       */
      _getSelected: function(index, selected) {

        return index === selected;

      },

      /**
       * Get Selected Class function
       * @param  {number} index - index of selected element.
       * @param  {number} selected - the selected element.
       */
      _getSelectedClass: function(index, selected) {

        return index == selected ? 'selected' : '';

      },

      /**
       * On Tap function
       * Sets selected slide on tap.
       * @param  {event} e - event fired from tap.
       */
      _onTap: function(e) {

        if (this._isAutoPlay) {
          this._stopAutoPlay();
        }

        this._setSelected(e.model.index);

      },

      /**
       * Respond to swipes
       * @param {event} e
       */
      _onSwipe: function(e) {

        var dir = e.type === 'swipe-right' ? 1 : -1;
        var step = this._isRtl() ? 1 : -1;

        if (this._isAutoPlay) {
          this._stopAutoPlay();
        }

        if (this.hasAttribute('locked')) {

          this._setSelected(this._selected + step * dir);

        } else {

          if (e.type === 'swipe-right') {
            if(this._selected === 0) {

              this._setSelected(this._items.length - 1);

            } else {

              this._setSelected(this._selected - 1);

            }
          } else {
            if((this._selected + 1) > (this._items.length - 1)) {

              this._setSelected(0);

            } else {

              this._setSelected(this._selected + 1);

            }
          }      

        }

      },

      /**
       * Select next function
       */
      _selectNext: function() {

        if((this._selected + 1) > (this._items.length - 1)) {
          this._setSelected(0);
        } else {
          this._setSelected(this._selected + 1);
        }

      },

      /**
       * Select prev function
       */
      _selectPrev: function() {

        if(this._selected === 0) {
          this._setSelected(this._items.length - 1);
        } else {
          this._setSelected(this._selected - 1);
        }

      },

      /**
       * swipe behavior
       * @param {event} e
       */
      _onDown: function(event) {

        this._x = event.detail.x;
        this._y = event.detail.y;

      },

      /**
       * swipe behavior
       * @param {event} e
       */
      _onUp: function(event) {

        var dx = event.detail.x - this._x;
        var dy = event.detail.y - this._y;
        var xDirection = dx > 0;
        var name = xDirection ? 'swipe-right' : 'swipe-left';

        if (Math.abs(dx) > this.horizontalThreshold && Math.abs(dy) < this.verticalThreshold) {

          this.fire(name);
          
        }
      },

       /**
       * continous loop
       */
       _autoPlay: function() {
         this.autoPlayer = setInterval(function() {
           this._selectNext();
         }.bind(this), this.transitionTime);
       },

       /**
       * Stop carousel loop
       */
      _stopAutoPlay: function() {
       this._isAutoPlay = false;
        clearInterval(this.autoPlayer);
      },

      /**
       * Start carousel loop
       */
      _startAutoPlay: function() {
       this._isAutoPlay = true;
       this._autoPlay();
      },

      _clamp: function(value, min, max) {

        return Math.max(Math.min(max, value), min);

      }

    });
  })();
  </script>
</dom-module>
